package eu.dnetlib.uoamonitorservice.entities;

import eu.dnetlib.uoamonitorservice.dto.TopicFull;
import eu.dnetlib.uoamonitorservice.generics.Common;
import eu.dnetlib.uoamonitorservice.generics.TopicGeneric;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.Objects;
import java.util.stream.Collectors;

@Document
public class Topic extends TopicGeneric<String> {

    public Topic() {
        super();
    }

    public Topic(TopicFull topic) {
        super(topic);
        this.categories = topic.getCategories().stream().map(Common::getId).collect(Collectors.toList());
        this.categories.removeIf(Objects::isNull);
    }
}
