package eu.dnetlib.uoamonitorservice.generics;

import com.fasterxml.jackson.annotation.JsonProperty;
import eu.dnetlib.uoamonitorservice.primitives.Visibility;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.LastModifiedDate;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TopicGeneric<StringOrCategory> extends Common {
    protected String icon;
    protected List<StringOrCategory> categories;

    public TopicGeneric() {
    }

    public TopicGeneric(TopicGeneric topic) {
        id = topic.getId();
        name = topic.getName();
        alias = topic.getAlias();
        description = topic.getDescription();
        icon = topic.getIcon();
        setVisibility(topic.getVisibility());
        creationDate = topic.getCreationDate();
        updateDate = topic.getUpdateDate();
        defaultId = topic.getDefaultId();
    }

    public void copyFromDefault(TopicGeneric defaultTopic) {
        setName(defaultTopic.getName());
        setAlias(defaultTopic.getAlias());
        setDescription(defaultTopic.getDescription());
        setIcon(defaultTopic.getIcon());
        setVisibility(defaultTopic.getVisibility());
        setCreationDate(defaultTopic.getCreationDate());
        setUpdateDate(defaultTopic.getUpdateDate());
        setDefaultId(defaultTopic.getId());
        setCategories(new ArrayList<>());
    }


    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public List<StringOrCategory> getCategories() {
        return categories;
    }

    public void setCategories(List<StringOrCategory> categories) {
        this.categories = categories;
    }
}
